_global.checkGround = function(character, height, loop)
{
   if(loop < 16)
   {
      loop = loop + 1;
      if(_root.game.level.ground.hitTest(character._x + _root.game._x,character._y + height + _root.game._y,true))
      {
         character._y -= 1;
         _root.playerDy = 0;
         if(_root.game.level.ground.hitTest(character._x + _root.game._x,character._y + height + _root.game._y,true))
         {
            _global.checkGround(character,height,loop);
         }
         return true;
      }
      if(_root.onPlatform)
      {
         return true;
      }
      return false;
   }
};
_global.checkCeiling = function(character, height, loop)
{
   if(loop < 16)
   {
      loop = loop + 1;
      if(_root.game.level.ground.hitTest(character._x + _root.game._x,character._y - height + _root.game._y,true) && !_root.game.level.ground.hitTest(character._x + _root.game._x,character._y + height + _root.game._y,true))
      {
         character._y += 1;
         _root.playerDy = 0;
         if(_root.game.level.ground.hitTest(character._x + _root.game._x,character._y - height + _root.game._y,true))
         {
            _global.checkCeiling(character,height,loop);
         }
         return true;
      }
      return false;
   }
};
_global.checkEdge = function(character, height, dx)
{
   if(_root.game.level.ground.hitTest(character._x + _root.game._x + dx,character._y + height + _root.game._y,true))
   {
      return true;
   }
   return false;
};
_global.checkWall = function(character, height, dx)
{
   if(_root.game.level.ground.hitTest(character._x + _root.game._x + dx,character._y + height / 2 + _root.game._y,true))
   {
      return true;
   }
   return false;
};
_global.checkPlayer = function(character, dir, offset)
{
   if(offset == undefined)
   {
      offset = 0;
   }
   if(_root.game.player.hitTest(character._x + _root.game._x + _root.playerWidth * dir + _root.playerDx,character._y + _root.game._y + offset,true))
   {
      return true;
   }
   return false;
};
_global.shootWeapon = function(weapon, x, y, speed)
{
   _root.weaponCount = _root.weaponCount + 1;
   _root.game.batarang.duplicateMovieClip(weapon + _root.weaponCount,_root.weaponCount);
   _root.game[weapon + _root.weaponCount]._x = x;
   _root.game[weapon + _root.weaponCount]._y = y;
   _root.game[weapon + _root.weaponCount].weaponDir = _root.playerDir;
   _root.game[weapon + _root.weaponCount].speed = speed;
   _root.game[weapon + _root.weaponCount].onEnterFrame = function()
   {
      this._x += this.weaponDir * this.speed;
      if(Math.abs(this._x - _root.game.player._x) > 500)
      {
         delete this.onEnterFrame;
         this._y = 2000;
      }
   };
};
_global.checkBatarang = function(char)
{
   i = _root.weaponCount;
   if(i > _root.weaponCount - 5)
   {
      if(_root.game["batarang" + i].hitTest(char))
      {
         _root.curBat = _root.game["batarang" + i];
         return true;
      }
      return false;
   }
};
_global.shootGrappling = function(x, y, angle)
{
   _global.startSwing(_root.game.player,_root.game.player._x + _root.playerDir * 100,y);
};
_root.swingAngle = 0;
_root.swingDir = 1;
_root.swingX = 0;
_root.swingY = 0;
_global.radiansToDegrees = function(radians)
{
   degrees = int(radians * 57.29577951308232);
   if(degrees < 0)
   {
      degrees += 360;
   }
   return degrees;
};
_global.degreesToRadians = function(degrees)
{
   radians = degrees * 0.017453292519943295;
   return radians;
};
_global.startSwing = function(swingObj, gx, gy)
{
   _root.swingDir = - _root.playerDir;
   _root.swingX = gx;
   _root.swingY = gy;
   rx = swingObj._x - _root.swingX;
   ry = swingObj._y - _root.swingY;
   radius = Math.sqrt(rx * rx + ry * ry);
   _root.swingAngle = Math.acos(rx / radius);
   _root.playerSwinging = true;
};
_global.grapplingSwing = function(swingObj)
{
   rx = swingObj._x - _root.swingX;
   ry = swingObj._y - _root.swingY;
   radius = Math.sqrt(rx * rx + ry * ry);
   swingObj._x = _root.swingX + Math.cos(_root.swingAngle) * radius;
   swingObj._y = _root.swingY + Math.sin(_root.swingAngle) * radius;
   if(_global.radiansToDegrees(_root.swingAngle) > 160)
   {
      _root.swingDir = -1;
   }
   else if(_global.radiansToDegrees(_root.swingAngle) < 20)
   {
      _root.swingDir = 1;
   }
   swingSpeed = (80 - Math.abs(_global.radiansToDegrees(_root.swingAngle) - 90)) / 4;
   if(swingSpeed < 1)
   {
      swingSpeed = 1;
   }
   _root.swingAngle += _global.degreesToRadians(_root.swingDir * swingSpeed);
   _root.playerDx = (- swingSpeed) * _root.swingDir * 2;
};
_global.grapplingLines = function()
{
   if(_root.playerSwinging)
   {
      this.clear();
      this.lineStyle(2,CCCCCC,100);
      this.moveTo(_root.game.player._x + _root.game._x,_root.game.player._y + _root.game._y);
      this.lineTo(_root.swingX + _root.game._x,_root.swingY + _root.game._y);
   }
   else
   {
      this.clear();
   }
};
_global.followPlayer = function()
{
   this._x = _root.game.player._x;
   this._y = _root.game.player._y;
};
